CodeSamejimaIRTinflated='
   data {
     int<lower=0> N;  #individuos
     int<lower=0> nit; #items
     real z[N,nit]; #resposta
   }
   parameters {
     real tau[N]; #theta
     real icept[nit]; #beta
     real ln_sigma2[nit]; #log delta
     real ln_phi[nit]; #log alfa
     real b0[nit]; #inflated 0
     real b1[nit]; #inflated 1
   }
   transformed parameters{
     real<lower=0> sigma2[nit]; #delta
     real<lower=0> phi[nit];    #alpha
     for(i in 1:nit){
       phi[i]=exp(ln_phi[i]);
       sigma2[i]=exp(ln_sigma2[i]);
     } 
   }
   model {
     for(p in 1:N){
      tau[p]~normal(0,1);  #prior to theta
     #likelihood without zeros, ones or missing
     for(i in 1:nit){
       if(z[p,i]!=0 && z[p,i]!=1 && z[p,i]!=-999){ 
        1~bernoulli(1/(1+exp(-(b1[i]-phi[i]*tau[p])))-1/(1+exp(-(b0[i]-phi[i]*tau[p]))));   
          #logis(b1-alfa*theta)-logis(b0-alfa*theta)
        z[p,i]~normal(icept[i]+phi[i]*tau[p],sqrt(sigma2[i]));    #mu=beta+alpha*theta and sigma   
       }
     #likelihood to zero
       else if(z[p,i]==0)
        1~bernoulli(1/(1+exp(-(b0[i]-phi[i]*tau[p])))); 
     #likelihood ones or missing      
       else 
        1~bernoulli(1-1/(1+exp(-(b1[i]-phi[i]*tau[p]))));      
     }
     }
#item priors
     for(i in 1:nit){
      #inflated
       b0[i]~normal(0,10);
       b1[i]~normal(0,10)T[b0[i],];
      #icept is beta, sigma2 is delta, phi is alfa
       icept[i]~normal(0,10) ;  #normal
       ln_sigma2[i]~normal(0,10); #lognormal
       ln_phi[i]~normal(0,10);    #lognormal
     }
   }'


SamejimaIRTinf=stan_model(model_name="SamejimaIRT_inflated",model_code=CodeSamejimaIRTinflated)
   

 