mfBoundIRTinf=function(fit, z, model){      # most of the work is calculating the bayes factor. WAIC and DIC are calculated at the end
z=as.matrix(z)
n_eff=median(summary(fit)$summary[, "n_eff"])

tau.samples=extract(fit,"tau")$tau
ti.samples=extract(fit,"icept")$icept
ln_phi.samples=extract(fit,"ln_phi")$ln_phi
ln_sigma2.samples=extract(fit,"ln_sigma2")$ln_sigma2
b0.samples=extract(fit,"b0")$b0
b1.samples=extract(fit,"b1")$b1

tau.est=apply(tau.samples,2,mean)
ti.est=apply(ti.samples,2,mean)
ln_phi.est=apply(ln_phi.samples,2,mean)
ln_sigma2.est=apply(ln_sigma2.samples,2,mean)
b0.est=apply(b0.samples,2,mean)
b1.est=apply(b1.samples,2,mean)

N=length(tau.est)
nit=length(ti.est)
no_iter=nrow(tau.samples)

###
n1=n2=no_iter/2

full.samples=cbind(tau.samples,ti.samples,ln_phi.samples,ln_sigma2.samples,b0.samples,b1.samples)
tau.ind=1:N   
ti.ind=1:nit+N
ln_phi.ind=1:nit+N+nit
ln_sigma2.ind=1:nit+N+nit*2
b0.ind=1:nit+N+nit*3
b1.ind=1:nit+N+nit*4


post.batch1=full.samples[1:n1,]
post.batch2=full.samples[(n1+1):(2*n1),]

propos.me.p=apply(post.batch1[,tau.ind],2,mean)
propos.me.i=apply(post.batch1[,(N+1):(N+nit*5)],2,mean)

propos.cov.p=diag(diag(cov(post.batch1[,tau.ind])))
propos.cov.i=cov(post.batch1[,(N+1):(N+nit*5)])

propos.samples.p=mvrnorm(n2,propos.me.p,propos.cov.p)
propos.samples.i=mvrnorm(n2,propos.me.i,propos.cov.i)

error=which((propos.samples.i[,b1.ind-N] - propos.samples.i[,b0.ind-N])<=0,arr.ind=T)[,1]
while(length(error>0)){ 
 propos.samples.i[error,]=mvrnorm(length(error),propos.me.i,propos.cov.i)
 error=which((propos.samples.i[,b1.ind-N] - propos.samples.i[,b0.ind-N])<=0,arr.ind=T)[,1]
}

propos.samples=cbind(propos.samples.p,propos.samples.i)

propos.me=c(propos.me.p,propos.me.i)
propos.cov=rbind(cbind(propos.cov.p,matrix(0,N,5*nit)),cbind(matrix(0,5*nit,N),propos.cov.i))
 
debug1=matrix(,n1,5)

log.l2=c()
for(i in 1:n2){
  tau.tmp2=propos.samples[i,tau.ind]
  ti.tmp2=propos.samples[i,ti.ind]
  ln_phi.tmp2=propos.samples[i,ln_phi.ind]
  ln_sigma2.tmp2=propos.samples[i,ln_sigma2.ind]
  b0.tmp2=propos.samples[i,b0.ind]
  b1.tmp2=propos.samples[i,b1.ind]
  
  
  ou5=ou1=ou2=ou3=ou4=c()
  for(p in 1:N){
    ind=which(z[p,]<1 & z[p,]>0 & z[p,]!=-999)
    tmp=c() 
     if(model=="samejima") 
    tmp[ind] = -log(z[p,ind])-log(1-z[p,ind])+dnorm(qlogis(z[p,ind]),ti.tmp2[ind]+exp(ln_phi.tmp2[ind])*tau.tmp2[p],exp(.5*ln_sigma2.tmp2[ind]),log=T)
    tmp[ind]=tmp[ind]+ log(  plogis(b1.tmp2[ind]-exp(ln_phi.tmp2[ind])*tau.tmp2[p]) -  plogis(b0.tmp2[ind]-exp(ln_phi.tmp2[ind])*tau.tmp2[p]))
    ind=which(z[p,]==0)
    tmp[ind] =log( plogis(b0.tmp2[ind]-exp(ln_phi.tmp2[ind])*tau.tmp2[p]))
    ind=which(z[p,]==1)
    tmp[ind] =log( 1-plogis(b1.tmp2[ind]-exp(ln_phi.tmp2[ind])*tau.tmp2[p]))
    ou1[p]=sum(tmp,na.rm=T) 
    ou4[p]=dnorm(tau.tmp2[p],log=T)
  }
  ou2=sum(log(dnorm(ln_phi.tmp2,0,10))+log(dnorm(ln_sigma2.tmp2,0,10))+log(dnorm(ti.tmp2,0,10)) +log(dnorm(b0.tmp2,0,10))+log(dnorm(b1.tmp2,0,10)/pnorm(b0.tmp2,0,10,low=F)))
  ou3=dmvnorm(c(ti.tmp2,ln_phi.tmp2,ln_sigma2.tmp2,b0.tmp2,b1.tmp2),propos.me[-(1:N)][1:(5*nit)],propos.cov[-(1:N),-(1:N)][1:(5*nit),1:(5*nit)],log=T)
  ou5=dmvnorm(tau.tmp2,propos.me[1:N],propos.cov[(1:N),(1:N)],log=T)      
  
  log.l2[i]=sum(ou1)+sum(ou4)+ou2 - (ou5+ou3)
  debug1[i,1:5]=c(sum(ou1),sum((ou4)),ou2, (ou5), (ou3))
}

log.l1=mll1=c()
llb=matrix(,N,n1)
for(i in 1:n1){
  tau.tmp1=post.batch2[i,tau.ind]
  ti.tmp1=post.batch2[i,ti.ind]
  ln_phi.tmp1=post.batch2[i,ln_phi.ind]
  ln_sigma2.tmp1=post.batch2[i,ln_sigma2.ind]
  b0.tmp1=post.batch2[i,b0.ind]
  b1.tmp1=post.batch2[i,b1.ind]
  
  ou5=ou1=ou2=ou3=ou4=c()
   for(p in 1:N){
      ind=which(z[p,]<1 & z[p,]>0 & z[p,]!=-999)
      tmp=c() 
         if(model=="samejima") 
      tmp[ind] = -log(z[p,ind])-log(1-z[p,ind])+dnorm(qlogis(z[p,ind]),ti.tmp1[ind]+exp(ln_phi.tmp1[ind])*tau.tmp1[p],exp(.5*ln_sigma2.tmp1[ind]),log=T)

      tmp[ind]=tmp[ind]+ log(  plogis(b1.tmp1[ind]-exp(ln_phi.tmp1[ind])*tau.tmp1[p]) -  plogis(b0.tmp1[ind]-exp(ln_phi.tmp1[ind])*tau.tmp1[p]))
      ind=which(z[p,]==0)
      tmp[ind] =log( plogis(b0.tmp1[ind]-exp(ln_phi.tmp1[ind])*tau.tmp1[p]))
      ind=which(z[p,]==1)
      tmp[ind] =log( 1-plogis(b1.tmp1[ind]-exp(ln_phi.tmp1[ind])*tau.tmp1[p]))
      ou1[p]=sum(tmp,na.rm=T) 
      ou4[p]=dnorm(tau.tmp1[p],log=T)
      llb[p,i]=ou1[p]
    }
    ou2=sum(log(dnorm(ln_phi.tmp1,0,10))+log(dnorm(ln_sigma2.tmp1,0,10))+log(dnorm(ti.tmp1,0,10)) +log(dnorm(b0.tmp1,0,10))+log(dnorm(b1.tmp1,0,10)/pnorm(b0.tmp1,0,10,low=F)))
    ou3=dmvnorm(c(ti.tmp1,ln_phi.tmp1,ln_sigma2.tmp1,b0.tmp1,b1.tmp1),propos.me[-(1:N)][1:(5*nit)],propos.cov[-(1:N),-(1:N)][1:(5*nit),1:(5*nit)],log=T)
    ou5=dmvnorm(tau.tmp1,propos.me[1:N],propos.cov[(1:N),(1:N)],log=T)      
     
  log.l1[i]=sum(ou1) + sum(ou4)+ou2 - (ou5+ou3)
  mll1[i]= sum(ou1) + sum(ou4)
}

r1=c()
r1[1]=0.1
for(it in 1:500){
    if(it==1) l_star1=median(log.l1)
    r1[it+1]= mean(exp(log.l2-l_star1) / (.5 * exp(log.l2-l_star1) + .5 * r1[it])) / ((n1/n_eff)* mean(1 / (.5 * exp(log.l1-l_star1) + .5 * r1[it])))
}

###########
#DEVIANCE #
###########

lla=matrix(,N,n1)
for(i in 1:n1){
  tau.tmp1=post.batch1[i,tau.ind]
  ti.tmp1=post.batch1[i,ti.ind]
  ln_phi.tmp1=post.batch1[i,ln_phi.ind]
  ln_sigma2.tmp1=post.batch1[i,ln_sigma2.ind]
  b0.tmp1=post.batch1[i,b0.ind]
  b1.tmp1=post.batch1[i,b1.ind]
  
  ou5=ou1=ou2=ou3=ou4=c()
  for(p in 1:N){
     ind=which(z[p,]<1 & z[p,]>0 & z[p,]!=-999)
     tmp=c() 
      if(model=="samejima") 
     tmp[ind] = -log(z[p,ind])-log(1-z[p,ind])+dnorm(qlogis(z[p,ind]),ti.tmp1[ind]+exp(ln_phi.tmp1[ind])*tau.tmp1[p],exp(.5*ln_sigma2.tmp1[ind]),log=T)
 
     tmp[ind]=tmp[ind]+ log(  plogis(b1.tmp1[ind]-exp(ln_phi.tmp1[ind])*tau.tmp1[p]) -  plogis(b0.tmp1[ind]-exp(ln_phi.tmp1[ind])*tau.tmp1[p]))
     ind=which(z[p,]==0)
     tmp[ind] =log( plogis(b0.tmp1[ind]-exp(ln_phi.tmp1[ind])*tau.tmp1[p]))
     ind=which(z[p,]==1)
     tmp[ind] =log( 1-plogis(b1.tmp1[ind]-exp(ln_phi.tmp1[ind])*tau.tmp1[p]))
     ou1[p]=sum(tmp,na.rm=T) 
     lla[p,i]=ou1[p]
   }
}
dev.mean=c()
  for(p in 1:N){
     ind=which(z[p,]<1 & z[p,]>0 & z[p,]!=-999)
     tmp=c() 
     if(model=="samejima") 
     tmp[ind] = -log(z[p,ind])-log(1-z[p,ind])+dnorm(qlogis(z[p,ind]),ti.est[ind]+exp(ln_phi.est[ind])*tau.est[p],exp(.5*ln_sigma2.est[ind]),log=T)

     tmp[ind]=tmp[ind]+ log(  plogis(b1.est[ind]-exp(ln_phi.est[ind])*tau.est[p]) -  plogis(b0.est[ind]-exp(ln_phi.est[ind])*tau.est[p]))
     ind=which(z[p,]==0)
     tmp[ind] =log( plogis(b0.est[ind]-exp(ln_phi.est[ind])*tau.est[p]))
     ind=which(z[p,]==1)
     tmp[ind] =log( 1-plogis(b1.est[ind]-exp(ln_phi.est[ind])*tau.est[p]))
     dev.mean[p]=sum(tmp,na.rm=T)
 }

ll=cbind(lla,llb)
DIC=2*mean(-2*apply(ll,2,sum))-sum(-2*dev.mean)
WAIC = -2*sum(log(apply(exp(ll),1,mean))) + 2 * sum(apply(ll,1,var))
return(list(r1=r1[501],l_star=l_star1,DIC=DIC,WAIC=WAIC,error=length(error)))
}

